



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MD5盐值加密</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MD5盐值加密</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 17:56:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>加密思路</h2>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/736706/201703/736706-20170315140332354-1733437707.png"></p>
<h2>思路解析：（数据解析过程基于16进制来处理的，加密后为16进制字符串）</h2>
<p><strong>加密阶段：</strong></p>
<p>对一个字符串进行MD5加密，我们需要使用到MessageDigest(消息摘要对象)，需要一个盐值（salt），这个值可以是我们在业务中的一个标识号，比如银行业务中的商户号。</p>
<p>然后对使用salt对password进行组合加密，形成一个加密串Encryp_password，但这时候并不是真正完整的加密串，我们还需要将salt放到加密串的最前面，方便在数据验证时，获取salt。</p>
<p>因此最终的加密串为：SAL_Encryp_password=salt+Encryp_password.</p>
<p><strong>解密验证阶段（实际上就是源字符串的再加密）：</strong></p>
<p>我们需要根据加密后的加密串获取到salt，然后使用salt对源字符串进行加密，得到新的加密串Encryp_password，然后两者相比，如果比对上，验证成功，否则验证失败！</p>
<p><strong>加密类</strong></p>
<div>
<pre class="prettyprint linenums">package com.alivn.utils;<br />
import java.io.UnsupportedEncodingException;<br />
import java.security.MessageDigest;<br />
import java.security.NoSuchAlgorithmException;<br />
import java.security.SecureRandom;<br />
import java.util.Arrays;

/**<br />
 * Created by Stringbuilder_Sun on 2017/3/15.<br />
 */<br />
public class MD5Encoder {

    private static final String HEX_NUMS_STR="0123456789ABCDEF";<br />
    private static final Integer SALT_LENGTH = 12;

    /**<br />
     * 将16进制字符串转换成字节数组<br />
     * @param hex<br />
     * @return<br />
     */<br />
    public static byte[] hexStringToByte(String hex) {<br />
        int len = (hex.length() / 2);<br />
        byte[] result = new byte[len];<br />
        char[] hexChars = hex.toCharArray();<br />
        for (int i = 0; i &lt; len; i++) {<br />
            int pos = i * 2;<br />
            result[i] = (byte) (HEX_NUMS_STR.indexOf(hexChars[pos]) &lt;&lt; 4<br />
                    | HEX_NUMS_STR.indexOf(hexChars[pos + 1]));<br />
        }<br />
        return result;<br />
    }

    /**<br />
     * 将指定byte数组转换成16进制字符串<br />
     * @param b<br />
     * @return<br />
     */<br />
    public static String byteToHexString(byte[] b) {<br />
        StringBuffer hexString = new StringBuffer();<br />
        for (int i = 0; i &lt; b.length; i++) {<br />
            String hex = Integer.toHexString(b[i] &amp; 0xFF);<br />
            if (hex.length() == 1) {<br />
                hex = '0' + hex;<br />
            }<br />
            hexString.append(hex.toUpperCase());<br />
        }<br />
        return hexString.toString();<br />
    }

    /**<br />
     * 验证口令是否合法<br />
     * @param password<br />
     * @param passwordInDb<br />
     * @return<br />
     * @throws NoSuchAlgorithmException<br />
     * @throws UnsupportedEncodingException<br />
     */<br />
    public static boolean validPassword(String password, String passwordInDb)<br />
            throws NoSuchAlgorithmException, UnsupportedEncodingException {<br />
        //将16进制字符串格式口令转换成字节数组<br />
        byte[] pwdInDb = hexStringToByte(passwordInDb);<br />
        //声明盐变量<br />
        byte[] salt = new byte[SALT_LENGTH];<br />
        //将盐从&lt;a href="http://lib.csdn.net/base/mysql" class='replace_word' title="MySQL知识库" target='_blank' style='color:#df3434; font-weight:bold;'&gt;数据库&lt;/a&gt;中保存的口令字节数组中提取出来<br />
        System.arraycopy(pwdInDb, 0, salt, 0, SALT_LENGTH);<br />
        //创建消息摘要对象<br />
        MessageDigest md = MessageDigest.getInstance("MD5");<br />
        //将盐数据传入消息摘要对象<br />
        md.update(salt);<br />
        //将口令的数据传给消息摘要对象<br />
        md.update(password.getBytes("UTF-8"));<br />
        //生成输入口令的消息摘要<br />
        byte[] digest = md.digest();<br />
        //声明一个保存数据库中口令消息摘要的变量<br />
        byte[] digestInDb = new byte[pwdInDb.length - SALT_LENGTH];<br />
        //取得数据库中口令的消息摘要<br />
        System.arraycopy(pwdInDb, SALT_LENGTH, digestInDb, 0, digestInDb.length);<br />
        //比较根据输入口令生成的消息摘要和数据库中消息摘要是否相同<br />
        if (Arrays.equals(digest, digestInDb)) {<br />
            //口令正确返回口令匹配消息<br />
            return true;<br />
        } else {<br />
            //口令不正确返回口令不匹配消息<br />
            return false;<br />
        }<br />
    }

    /**<br />
     * 获得加密后的16进制形式口令<br />
     * @param password<br />
     * @return<br />
     * @throws NoSuchAlgorithmException<br />
     * @throws UnsupportedEncodingException<br />
     */<br />
    public static String getEncryptedPwd(String password)<br />
            throws NoSuchAlgorithmException, UnsupportedEncodingException {<br />
        //声明加密后的口令数组变量<br />
        byte[] pwd = null;<br />
        //随机数生成器<br />
        SecureRandom random = new SecureRandom();<br />
        //声明盐数组变量<br />
        byte[] salt = new byte[SALT_LENGTH];<br />
        //将随机数放入盐变量中<br />
        random.nextBytes(salt);

        //声明消息摘要对象<br />
        MessageDigest md = null;<br />
        //创建消息摘要<br />
        md = MessageDigest.getInstance("MD5");<br />
        //将盐数据传入消息摘要对象<br />
        md.update(salt);<br />
        //将口令的数据传给消息摘要对象<br />
        md.update(password.getBytes("UTF-8"));<br />
        //获得消息摘要的字节数组<br />
        byte[] digest = md.digest();

        //因为要在口令的字节数组中存放盐，所以加上盐的字节长度<br />
        pwd = new byte[digest.length + SALT_LENGTH];<br />
        //将盐的字节拷贝到生成的加密口令字节数组的前12个字节，以便在验证口令时取出盐<br />
        System.arraycopy(salt, 0, pwd, 0, SALT_LENGTH);<br />
        //将消息摘要拷贝到加密口令字节数组从第13个字节开始的字节<br />
        System.arraycopy(digest, 0, pwd, SALT_LENGTH, digest.length);<br />
        //将字节数组格式加密后的口令转化为16进制字符串格式的口令<br />
        return byteToHexString(pwd);<br />
    }

}</pre>
</div>
<p><strong>验证类</strong></p>
<div>
<pre class="prettyprint linenums">package com.alivn.utils;

import java.io.UnsupportedEncodingException;<br />
import java.security.NoSuchAlgorithmException;<br />
import java.util.HashMap;<br />
import java.util.Map;

public class  TestMD5Ecoder{<br />
    private static Map users = new HashMap();

    public static void main(String[] args){<br />
        String userName = "zyg";<br />
        String password = "123";<br />
        registerUser(userName,password);

        userName = "changong";<br />
        password = "456";<br />
        registerUser(userName,password);

        String loginUserId = "zyg";<br />
        String pwd = "1232";<br />
        try {<br />
            if(loginValid(loginUserId,pwd)){<br />
                System.out.println("欢迎登陆！！！");<br />
            }else{<br />
                System.out.println("口令错误，请重新输入！！！");<br />
            }<br />
        } catch (NoSuchAlgorithmException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        } catch (UnsupportedEncodingException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        }<br />
    }

    /**<br />
     * 注册用户<br />
     *<br />
     * @param userName<br />
     * @param password<br />
     */<br />
    public static void registerUser(String userName,String password){<br />
        String encryptedPwd = null;<br />
        try {<br />
            encryptedPwd = MD5Encoder.getEncryptedPwd(password);

            users.put(userName, encryptedPwd);

        } catch (NoSuchAlgorithmException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        } catch (UnsupportedEncodingException e) {<br />
            // TODO Auto-generated catch block<br />
            e.printStackTrace();<br />
        }<br />
    }

    /**<br />
     * 验证登陆<br />
     *<br />
     * @param userName<br />
     * @param password<br />
     * @return<br />
     * @throws UnsupportedEncodingException<br />
     * @throws NoSuchAlgorithmException<br />
     */<br />
    public static boolean loginValid(String userName,String password)<br />
            throws NoSuchAlgorithmException, UnsupportedEncodingException{<br />
        String pwdInDb = (String)users.get(userName);<br />
        if(null!=pwdInDb){ // 该用户存在<br />
            return MD5Encoder.validPassword(password, pwdInDb);<br />
        }else{<br />
            System.out.println("不存在该用户！！！");<br />
            return false;<br />
        }<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy2w1g9.html">shell中&dollar;0&comma;&dollar;&quest;&comma;&dollar;&excl;等的特殊用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqln7p18.html">夺命雷公狗-----React---16--事件操作事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn27pjq.html">nginx安装及配置为简单的文件服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyr0v28.html">深入浅出Mybatis系列（十）---SQL执行流程分析（源码篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlkex68.html">【JavaScript】之【Object】</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw4gvk8.html">SQL查询数据的几大方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdze6d8.html">Mac 下Cordova开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydvp4jq.html">js节点解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/96og1py9.html">RxAndroid结合Retrofit，看看谁才是最佳拍档！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnrrov8.html">第 16 章 观察者模式【Observer Pattern】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okr2p19.html">初步掌握MapReduce的架构及原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okm5rl9.html">最简单轻便 的 sqlserver安装方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myzzn8.html">phpexcel导入excel处理大数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjpxwz8.html">Python内置函数&lpar;20&rpar;&mdash;&mdash;hex</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y2x4g8.html">序列化与反序列化中serialVersionUID的作用（通俗易懂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyp0wx9.html">bootstrap&lowbar;响应式布局简介&lowbar;媒体查询&lowbar;媒体选择器&lowbar;2x3x图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxey79.html">Maven更新后本地仓库jar后缀带有 lastUpdated</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyye0zgq.html">转载-增删改查sql语句语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn13w2q.html">progress进度条的样式修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjr5mvq.html">Deep Learning综述&lbrack;下&rsqb;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qllwy4eq.html">Problem C&colon; 重复子串&lpar;string&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25g7kvq.html">Spring Boot探究之旅--启动分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllwzd6q.html">django之Models和ORM</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w302nq.html">spring梳理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1lkdxq.html">Django Forms 表单</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5kdr7q.html">leetcode124</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zye1d39.html">&amp;lt&semi;记录&amp;gt&semi;TP5 关联模型使用（嵌套关联、动态排序以及隐藏字段）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25yjmvq.html">第三篇、Python函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv4j6l8.html">获取cxgrid footer内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j34zjq.html">安装SourceTree工具，无需注册就可以正常使用SourceTree</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
